# Deprecated API

## Contents

- Terminally Deprecated
- Interfaces
- Classes
- Exceptions
- Fields
- Methods

Terminally Deprecated Elements
Element
Description
jakarta.servlet.jsp.el.ImplicitObjectELResolver.getFeatureDescriptors(ELContext, Object)
jakarta.servlet.jsp.el.ImportELResolver.getFeatureDescriptors(ELContext, Object)
jakarta.servlet.jsp.el.NotFoundELResolver.getFeatureDescriptors(ELContext, Object)
jakarta.servlet.jsp.el.ScopedAttributeELResolver.getFeatureDescriptors(ELContext, Object)

Deprecated Interfaces
Interface
Description
jakarta.servlet.jsp.el.FunctionMapper
As of JSP 2.1, replaced by jakarta.el.FunctionMapper
jakarta.servlet.jsp.el.VariableResolver
As of JSP 2.1, replaced by jakarta.el.ELResolver

Deprecated Classes
Class
Description
jakarta.servlet.jsp.el.Expression
As of JSP 2.1, replaced by jakarta.el.ValueExpression
jakarta.servlet.jsp.el.ExpressionEvaluator
As of JSP 2.1, replaced by jakarta.el.ExpressionFactory

Deprecated Exceptions
Exceptions
Description
jakarta.servlet.jsp.el.ELException
As of JSP 2.1, replaced by jakarta.el.ELException
jakarta.servlet.jsp.el.ELParseException
As of JSP 2.1, replaced by jakarta.el.ELException

Deprecated Fields
Field
Description
jakarta.servlet.jsp.tagext.BodyTag.EVAL_BODY_TAG
As of Java JSP API 1.2, use BodyTag.EVAL_BODY_BUFFERED or IterationTag.EVAL_BODY_AGAIN.

Deprecated Methods
Method
Description
jakarta.servlet.jsp.el.ImplicitObjectELResolver.getFeatureDescriptors(ELContext, Object)
jakarta.servlet.jsp.el.ImportELResolver.getFeatureDescriptors(ELContext, Object)
jakarta.servlet.jsp.el.NotFoundELResolver.getFeatureDescriptors(ELContext, Object)
jakarta.servlet.jsp.el.ScopedAttributeELResolver.getFeatureDescriptors(ELContext, Object)
jakarta.servlet.jsp.JspContext.getExpressionEvaluator()
As of JSP 2.1, replaced by JspApplicationContext.getExpressionFactory()
jakarta.servlet.jsp.JspContext.getVariableResolver()
As of JSP 2.1, replaced by jakarta.el.ELContext.getELResolver() which can be obtained by jspContext.getELContext().getELResolver()
jakarta.servlet.jsp.JspException.getRootCause()
As of JSP 2.1, replaced by `java.lang.Throwable.getCause()`